#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <iostream>
#include <string>

using namespace std;

int main ()
{
    int sock, client;
    sockaddr_in addr, client_addr;
    socklen_t size;
    string buf;

    sock = socket (PF_INET, SOCK_DGRAM, 0);
    client = socket (PF_INET, SOCK_DGRAM, 0);

    memset (&addr, 0, sizeof (addr));
    memset (&client_addr, 0, sizeof (addr));
    client_addr.sin_family = PF_INET;
    addr.sin_family = PF_INET;
    addr.sin_port = htons (9000);
    addr.sin_addr.s_addr = htonl (INADDR_ANY);

    if (bind (sock, (struct sockaddr *) &addr, sizeof (struct sockaddr)))
        perror ("Bind");

    while (1)
    {
        size = sizeof (struct sockaddr);
        char buf_in;
        int r = recvfrom (sock, &buf_in, 1, 0, (struct sockaddr *) &client_addr, &size);
        int id = fork ();
        if (id == 0)
        {
            int client = socket (PF_INET, SOCK_DGRAM, 0);
            connect (client, (struct sockaddr *) &client_addr, size);
            if (write (client, &buf_in, 1) < 0) perror ("funkcja write");
            while (1)
            {
                char buf[100];
                int len = read (client, buf, 100);
                cout << "Odebrano od klienta: " << len << " znakow" << endl;
                cout << "Port: " << ntohs (client_addr.sin_port) << " adres: " << inet_ntoa (client_addr.sin_addr) << endl;
                int s = write (client, buf, len);
                cout << "Wyslano: " << s << " znakow." << endl;
            }
            
        } 
        else if (id > 0)
        {
            continue;
        }
        else perror ("Funkcja fork");

   
    }
    return 0;
}
